**General guidelines**

- Be sure to follow the [Security Releases general information](https://gitlab.com/gitlab-org/release/docs/blob/master/general/security/process.md) and [Security Releases as Release Manager](https://gitlab.com/gitlab-org/release/docs/blob/master/general/security/release-manager.md).
- Always work on [https://dev.gitlab.org/](https://dev.gitlab.org/). Do not push anything to [https://gitlab.com](https://gitlab.com)
- Deployment tasks (staging, production canary VMs, and production) should be done only if the patch is for the latest version. Feel free to delete those sections if they don't apply.

## Preparation

- [ ] Merge security merge requests using chatops:
   ```sh
   # In Slack:
   /chatops run release merge --security
   ```
- [ ] If any merge requests could not be merged, investigate what needs to be done to resolve this issues. Do **not** proceed unless it has been determined safe to do so.
- [ ] Merge `ce/<%= version.stable_branch %>` into `ee/<%= version.stable_branch(ee: true) %>`

## Packaging

- [ ] **Push `omnibus-gitlab/<%= version.stable_branch %>` to `dev` only: `git push dev <%= version.stable_branch %>`**
- [ ] Ping the Security Engineers so they can get started with the blog post. The blog post should also be done on https://dev.gitlab.org/ in a **private snippet**: BLOG_POST_SNIPPET

- [ ] Ensure [tests are green on CE]
- [ ] Ensure [tests are green on EE]

- [ ] Tag `<%= version.to_patch %>`:
   ```sh
   # In Slack:
   /chatops run release tag --security <%= version.to_patch %>
   ```
- [ ] Check that [EE packages are built] and [CE packages are built]

## Deploy

###  Deploy to Pre for QA testing

- [ ] Deploy `<%= version %>` to preprod
  ```sh
  # In Slack:
  /chatops run deploy <%= version.to_patch %>-ee.0 --pre
  ```

#### QA

The [QA task issue](https://gitlab.com/gitlab-org/release/tasks/issues?label_name%5B%5D=QA+task)
is manually generated, you can do so as follows:

```sh
# In Slack, replacing LAST_DEPLOYED_VERSION with the appropriate value:
/chatops run release qa --security vLAST_DEPLOYED_VERSION v<%= version %>
```

- [ ] Notify @appsec-team that packages are ready for QA
  ```sh
  # In Slack
  @appsec-team - Security release packages are available for QA.
  ```
- [ ] Wait for the QA tasks deadline to pass.

## Release

- [ ] This section should be done in coordination with the Security team, so **make sure to confirm with them before proceeding**
  ```sh
  # In Slack
  @appsec-team - We are ready to publish the security release packages for <%= version %>, please let us know if the blog post is ready.
  ```

- [ ] Publish the packages via ChatOps:
  ```
  # In Slack:
  /chatops run publish <%= version %>
  ```
- [ ] Create the `<%= version %>` version on [version.gitlab.com](https://version.gitlab.com/versions/new?version=<%= version %>). **Be sure to mark it as a security release.**
- [ ] Push `ce/<%= version.stable_branch %>` to all remotes
- [ ] Push `ee/<%= version.stable_branch(ee: true) %>` to all remotes
- [ ] Push `omnibus/<%= version.stable_branch %>` to all remotes
- [ ] Push CE, EE and omnibus tags to all remotes
- [ ] In the `#releases` channel, mention `@advocates` to tweet about the new release:
  ```
  !tweet "GitLab <%= version %> is released! BLOG_POST_URL DESCRIPTION OF THE CHANGES"
  ```
- [ ] Merge security MRs targeting master:
   ```sh
   # In Slack:
   /chatops run release merge --security --master
   ```
- [ ] Push `ce/master` to all remotes
- [ ] Push `ee/master` to all remotes
- [ ] Push `omnibus/master` to all remotes

---

For references:
- https://dev.gitlab.org/gitlab/gitlab-ee/commits/<%= version.stable_branch(ee: true) %>
- https://dev.gitlab.org/gitlab/gitlabhq/commits/<%= version.stable_branch %>
- https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.stable_branch %>

[tests are green on CE]: https://dev.gitlab.org/gitlab/gitlabhq/commits/<%= version.stable_branch %>
[tests are green on EE]: https://dev.gitlab.org/gitlab/gitlab-ee/commits/<%= version.stable_branch(ee: true) %>
[EE packages are built]: https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.stable_branch(ee: true) %>
[CE packages are built]: https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.stable_branch %>

[EE packages are built]: https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.stable_branch(ee: true) %>
[CE packages are built]: https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.stable_branch %>

[`gitlab/gitlab-ee`]: https://packages.gitlab.com/gitlab/gitlab-ee
[`gitlab/gitlab-ce`]: https://packages.gitlab.com/gitlab/gitlab-ce

[`security_qa_issue` task]: https://gitlab.com/gitlab-org/release-tools/blob/master/doc%2Frake-tasks.md#security_qa_issuefromtoversion

[staging.gitlab.com]: https://gitlab.com/gitlab-org/takeoff#deploying-gitlab
[GitLab.com]: https://gitlab.com/gitlab-org/takeoff#deploying-gitlab

[publicly acknowledged]: https://about.gitlab.com/vulnerability-acknowledgements/
